/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_timer.c 473 2007-08-10 06:59:14Z honda $
 */

/*
 *  ޥɥ饤СSH12Aѡ
 * 
 *  CMT0 
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"
 
/*
 *  ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
    CLOCK    cyc = TO_CLOCK(TIC_NUME, TIC_DENO);

    /*
     *  ޼ꤷޤư򳫻Ϥ롥
     */
    /* CMT0 */
    sil_wrh_mem((void*)CMSTR,
                (sil_reh_mem((void*)CMSTR) & ~CMSTR_STR0));

    /* ޾ͤΥå */
    assert(cyc <= MAX_CLOCK);             

    /* ʬ(PCLOCK/8)ߵ */
    sil_wrh_mem((void*)CMCSR_0, (CMCSR_CKS  | CMCSR_CMIE));

    /*constant쥸򥻥å */
    sil_wrh_mem((void*)CMCOR_0, cyc); 

    /* CMT0 */
    sil_wrh_mem((void*)CMSTR,
                (sil_reh_mem((void*)CMSTR) | CMSTR_STR0));      

    /* ׵򥯥ꥢ */
    sil_wrh_mem((void*)CMCSR_0,
                (sil_reh_mem((void*)CMCSR_0) & ~CMCSR_CMF));
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
    /* ޤ */
    sil_wrh_mem((void*)CMSTR,
                (sil_reh_mem((void*)CMSTR) & ~CMSTR_STR0));
    
    /* ׵򥯥ꥢ */
    sil_wrh_mem((void*)CMCSR_0,
                (sil_reh_mem((void*)CMCSR_0) & ~CMCSR_CMF));

}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
    /* ׵򥯥ꥢ */
    sil_wrh_mem((void*)CMCSR_0,
                (sil_reh_mem((void*)CMCSR_0) & ~CMCSR_CMF));
    
    i_begin_int(INTNO_TIMER);
    signal_time();                    /* ƥåζ */
    i_end_int(INTNO_TIMER);
}
