/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: sh2a_config.h 697 2007-12-25 04:43:57Z honda $
 */

/*
 *		ץå¸⥸塼SH2Aѡ
 *
 *  Υ󥯥롼ɥեϡsh7xxx_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_SH2A_CONFIG_H
#define TOPPERS_SH2A_CONFIG_H

/*
 *  ץåμ
 */
#define SH2A


/*
 *  IRQߤɤȽꤹ뤿Υޥ
 */
#define INTNO_IRQ0 		64U
#define INTNO_IRQ_MAX	71U
#define INTNO_IRQ(intno) ((INTNO_IRQ0 <= (intno)) && ((intno) <= INTNO_IRQ_MAX))
#define INTNO_TO_IRQNO(intno) (((intno) - INTNO_IRQ0))


#ifndef TOPPERS_MACRO_ONLY
/*
 * ͥ٥쥸
 */
Inline void
set_irc_ipr(uint32_t address, uint32_t offset, uint32_t val)
{
    uint32_t ipr_val;

    ipr_val = sil_reh_mem((void *) address);
    ipr_val &= ~(0x0FU << offset);
    ipr_val |= (uint32_t)val << offset;
    sil_wrh_mem((void *) address, ipr_val);
}

/*
 *  ߤ°
 */
Inline void
x_config_intatr(INTNO intno, ATR intatr)
{
    /*
     *  IRQΤߥݡȤ
     */
    if(INTNO_IRQ(intno) != 0U){
        uint32_t icr1_val = sil_reh_mem((void*)ICR1);
        uint32_t offset   = INTNO_TO_IRQNO(intno) * 2U;

        icr1_val &=  ~(0x03U << offset);
        
        if((intatr & TA_POSEDGE) != 0U) {
            /*
             *  ݥƥ֥å
             */
            icr1_val |= IRQ_POSEDGE << offset;            
        }

        if((intatr & TA_NEGEDGE) != 0U) {
            /*
             *  ͥƥ֥å
             */
            icr1_val |= IRQ_NEGEDGE << offset;                        
        }
        
        sil_wrh_mem((void*)ICR1, icr1_val);
    }
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ץå¸⥸塼SH12Aѡ
 */
#include "sh12a_gcc/prc_config.h"

#endif /* TOPPERS_SH2A_CONFIG_H */
